package com.fp.persistence.parmas.soli;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TARMSANCIONDECOMISO*/
@Embeddable
public class TarmSancionDecomisoKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CSANCIONDECOMISO", nullable=false,updatable=false)

/**
* Codigo de la sancion aplicada
*/
private String csanciondecomiso;

@Column(name="CDECOMISO", nullable=false,updatable=false)

/**
* Codigo del decomiso asociado 
*/
private Long cdecomiso;

/**Contructor por defecto*/
public TarmSancionDecomisoKey(){}
/**Contructor de TarmSancionDecomisoKey
@param pCsanciondecomiso Codigo de la sancion aplicada
@param pCdecomiso Codigo del decomiso asociado 
*/
public TarmSancionDecomisoKey(String pCsanciondecomiso,Long pCdecomiso){
 csanciondecomiso=pCsanciondecomiso;
 cdecomiso=pCdecomiso;
}
/**Obtiene el valor de csanciondecomiso
@return valor de csanciondecomiso*/
public String getCsanciondecomiso(){
  return csanciondecomiso;
}
/**Fija el valor de csanciondecomiso
@param pCsanciondecomiso nuevo Valor de csanciondecomiso*/
public void setCsanciondecomiso(String pCsanciondecomiso){
  csanciondecomiso=pCsanciondecomiso;
}

/**Obtiene el valor de cdecomiso
@return valor de cdecomiso*/
public Long getCdecomiso(){
  return cdecomiso;
}
/**Fija el valor de cdecomiso
@param pCdecomiso nuevo Valor de cdecomiso*/
public void setCdecomiso(Long pCdecomiso){
  cdecomiso=pCdecomiso;
}

/**Implementacion de la comparacion de TarmSancionDecomisoKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmSancionDecomisoKey))return false;
  TarmSancionDecomisoKey that = (TarmSancionDecomisoKey) o;
  if (this.getCsanciondecomiso() == null || that.getCsanciondecomiso() == null){
      return false;
  }
  if (! this.getCsanciondecomiso().equals(that.getCsanciondecomiso())){
    return false;
  }
  if (this.getCdecomiso() == null || that.getCdecomiso() == null){
      return false;
  }
  if (! this.getCdecomiso().equals(that.getCdecomiso())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmSancionDecomisoKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCsanciondecomiso() == null ? 0 : this.getCsanciondecomiso().hashCode());
    result = result * 37 + (this.getCdecomiso() == null ? 0 : this.getCdecomiso().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
